> For the complete documentation index, see [llms.txt](https://docs.parallels.com/landing/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.parallels.com/landing/ras-rest-api-guide/api-reference/infrastructure/providers/custom.md).

# Custom

## Create

> Create a new Custom Provider server to a site.

```json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/Provider/custom":{"post":{"tags":["0-Infrastructure/Providers//0-Basic Operations"],"summary":"Create","description":"Create a new Custom Provider server to a site.","operationId":"b9c9ffb4-58ad-4144-8b74-2524284f5417","parameters":[{"name":"noInstall","in":"query","description":"Specifies not to install the VDI agent on the server.\r\n            If this parameter is omitted, the agent will be push installed on the server using your RAS admin credentials.\r\n            To specify different credentials for push installation, specify the Username and Password parameters.","schema":{"type":"boolean"}},{"name":"username","in":"query","description":"An administrator account for push installing the VDI agent on the server.\r\n            If this parameter is omitted, your RAS admin username (and password) will be used.","schema":{"type":"string"}},{"name":"password","in":"query","description":"The password of the account specified in the Username parameter.","schema":{"type":"string"}},{"name":"noRestart","in":"query","description":"Specifies not to restart the server after the  RAS VDI Agent is installed when installing the VDI Agent.\r\n            If this parameter is omitted, the server will be restarted if required.","schema":{"type":"boolean"}},{"name":"noFireWallRules","in":"query","description":"Specifies not to add firewall rules to allow the RAS VDI Agent to communicate when installing the VDI Agent.\r\n            If this parameter is omitted, the firewall rules will not be added.","schema":{"type":"boolean"}}],"requestBody":{"description":"Provider settings","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/NewCustomProvider"}}}},"responses":{"201":{"description":"Created","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/CustomProvider"}}}},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"NewCustomProvider":{"required":["arguments","command","customProviderVersion","name","providerPassword","providerUsername","workdir"],"type":"object","properties":{"name":{"type":"string","description":"<para type=\"description\">The name of the Provider.</para>","nullable":true},"siteId":{"type":"integer","description":"<para type=\"description\">The site ID to which to add the specified server.</para>\r\n<para type=\"description\">If the parameter is omitted, the Licensing Server site ID will be used.</para>","format":"int32"},"vdiAgent":{"type":"string","description":"<para type=\"description\">FQDN or IP address of the server where the RAS VDI Agent is running.</para>\r\n<para type=\"description\"></para>","nullable":true},"providerUsername":{"type":"string","description":"<para type=\"description\">A user account to log in to the hypervisor management tool (e.g. VMware vCenter).</para>\r\n<para type=\"description\">In case of Azure, it is an ID of the application which will be used by VDI agent to manage Azure resources.</para>","nullable":true},"providerPassword":{"type":"string","description":"<para type=\"description\">The password of the account specified in the ProviderUsername parameter.</para>\r\n<para type=\"description\">In case of Azure, it is a secret key of the application which will be used by VDI agent to manage Azure resources.</para>","nullable":true},"preferredConnectionBrokerId":{"type":"integer","description":"<para type=\"description\">The preferred Connection Broker ID.</para>","format":"int32","nullable":true},"useAllGuests":{"type":"boolean","description":"<para type=\"description\">Use all guests.</para>","nullable":true},"customProviderVersion":{"$ref":"#/components/schemas/CustomProviderVersion"},"arguments":{"type":"string","description":"<para type=\"description\">Specifies the arguments to launch the script.</para>","nullable":true},"command":{"type":"string","description":"<para type=\"description\">Specifies the command to launch the script.</para>","nullable":true},"workdir":{"type":"string","description":"<para type=\"description\">Specifies the script working directory.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">Create provider of type Custom</para>\r\n<para type=\"description\"></para>"},"CustomProviderVersion":{"enum":[["0 = CustomProvider"]],"type":"string","description":"<para type=\"synopsis\">Custom Version</para>\r\n<para type=\"description\"></para>","format":"int32"},"CustomProvider":{"type":"object","properties":{"id":{"type":"integer","description":"<para type=\"description\">ID of the object.</para>","format":"int32"},"adminCreate":{"type":"string","description":"<para type=\"description\">User who created the object.</para>","nullable":true},"adminLastMod":{"type":"string","description":"<para type=\"description\">User who last modified the object.</para>","nullable":true},"timeCreate":{"type":"string","description":"<para type=\"description\">Time when the object was created.</para>","format":"date-time"},"timeLastMod":{"type":"string","description":"<para type=\"description\">Time when the object was last modified.</para>","format":"date-time"},"enabled":{"type":"boolean","description":"<para type=\"description\">Whether the server is enabled or not.</para>"},"description":{"type":"string","description":"<para type=\"description\">Description of the server.</para>","nullable":true},"siteId":{"type":"integer","description":"<para type=\"description\">ID of the site.</para>","format":"int32"},"inheritDefaultAgentSettings":{"type":"boolean","description":"<para type=\"description\">Whether the default Agent settings are inherited or not.</para>"},"vdiAgent":{"type":"string","description":"<para type=\"description\">FQDN or IP address of the server where the RAS VDI Agent is running.</para>","nullable":true},"preferredConnectionBrokerId":{"type":"integer","description":"<para type=\"description\">ID of the preferred Connection Broker.</para>","format":"int32"},"server":{"type":"string","description":"<para type=\"description\">Server name.</para>","nullable":true},"name":{"type":"string","description":"<para type=\"description\">Name of the Provider.</para>","nullable":true},"type":{"$ref":"#/components/schemas/ProviderMajorType"},"providerUsername":{"type":"string","description":"<para type=\"description\">A user account to log in to the hypervisor management tool (e.g. VMware vCenter).</para>\r\n<para type=\"description\">In case of Azure, it is a secret key of the application which will be used by VDI agent to manage Azure resources.</para>","nullable":true},"hostPort":{"type":"integer","description":"<para type=\"description\">Specifies the port number for the Provider.</para>","format":"int32"},"vdiPort":{"type":"integer","description":"<para type=\"description\">The port to communicate with the dedicated provider.</para>","format":"int32"},"directAddress":{"type":"string","description":"<para type=\"description\">Specifies the Provider server direct address.</para>","nullable":true},"sessionTimeout":{"type":"integer","description":"<para type=\"description\">Specifies the 'Disconnect Timeout'. 0 - No timeout.</para>","format":"int32"},"sessionLogoffTimeout":{"type":"integer","description":"<para type=\"description\">Specifies the 'Reset Timeout'. 0 - No timeout.</para>","format":"int32"},"allowURLAndMailRedirection":{"$ref":"#/components/schemas/AllowURLAndMailRedirection"},"supportShellURLNamespaceObjects":{"type":"boolean","description":"<para type=\"description\">Whether the 'Support Shell URL Namespace Objects' option is enabled or disabled.</para>"},"allowDragAndDrop":{"type":"boolean","description":"<para type=\"description\">Whether drag and drop is allowed or not.</para>"},"allowRemoteExec":{"type":"boolean","description":"<para type=\"description\">Whether remote execution is allowed or not.</para>"},"enableAppMonitoring":{"type":"boolean","description":"<para type=\"description\">Whether application monitoring is enabled or not.</para>"},"useRemoteApps":{"type":"boolean","description":"<para type=\"description\">Whether remote applications are used or not.</para>"},"fileTransferMode":{"$ref":"#/components/schemas/FileTransferControlMode"},"fileTransferLocation":{"type":"string","description":"<para type=\"description\">Location where the File Transfer takes place, if and where it is allowed.</para>","nullable":true},"fileTransferLockLocation":{"type":"boolean","description":"<para type=\"description\">Lock Location where the File Transfer takes place, if and where it is allowed.</para>"},"fileTransferSuppressPromptForUploadFiles":{"type":"boolean","description":"<para type=\"description\">Specifies if the 'Suppress prompt for upload files' option is enabled or disabled.</para>"},"fileTransferExistingFileMode":{"$ref":"#/components/schemas/FileTransferExistingFileMode"},"fileTransferAutoCloseWindow":{"type":"boolean","description":"<para type=\"description\">Specifies if the \"Close transfer window when complete\" option is enabled or disabled.</para>"},"enablePrinting":{"type":"boolean","description":"<para type=\"description\">Whether printing is enabled or not.</para>"},"enableTWAIN":{"type":"boolean","description":"<para type=\"description\">Whether TWAIN (Universal Scanning) is enabled or not.</para>"},"enableWIA":{"type":"boolean","description":"<para type=\"description\">Whether WIA (Universal Scanning) is enabled or not.</para>"},"useDefaultPrinterSettings":{"type":"boolean","description":"<para type=\"description\">Whether the default printer settings are used or not.</para>"},"removeClientNameFromPrinterName":{"type":"boolean","description":"<para type=\"description\">Specifies if 'Remove client name from printer name' option is enabled or disabled.</para>"},"removeSessionNumberFromPrinterName":{"type":"boolean","description":"<para type=\"description\">Specifies if 'Remove session number from printer name' option is enabled or disabled.</para>"},"printerNameFormat":{"$ref":"#/components/schemas/PrnNameFormat"},"enableDriveRedirectionCache":{"type":"boolean","description":"<para type=\"description\">Whether the Drive Redirection Cache is enabled or not.</para>"},"driveRedirectionFileCache":{"$ref":"#/components/schemas/DriveRedirectionFileCacheMode"},"manageRDPTransportProtocol":{"$ref":"#/components/schemas/ManageRDPTransportProtocol"},"useAllGuests":{"type":"boolean","description":"<para type=\"description\">Specifies whether all Guests are used or not.</para>"},"useDedicatedVDIAgent":{"type":"boolean","description":"<para type=\"description\">Whether a dedicated VDI Agent server is used or not.</para>"},"adminCredentials":{"type":"array","items":{"$ref":"#/components/schemas/AdminCredential"},"description":"<para type=\"description\">Admin credentials.</para>","nullable":true},"version":{"$ref":"#/components/schemas/CustomProviderVersion"},"arguments":{"type":"string","description":"<para type=\"description\">Arguments to launch the script.</para>","nullable":true},"command":{"type":"string","description":"<para type=\"description\">Command to launch the script.</para>","nullable":true},"workdir":{"type":"string","description":"<para type=\"description\">Script working directory.</para>","nullable":true},"variables":{"type":"array","items":{"$ref":"#/components/schemas/CustomizationVariable"},"description":"<para type=\"description\">Customization: Variables.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">Custom Provider</para>\r\n<para type=\"description\"></para>"},"ProviderMajorType":{"enum":[["9 = HyperV","10 = VMwareESXi","15 = VMwarevCenter","16 = HyperVFailover","18 = Nutanix","20 = ScaleComputing","21 = Azure","22 = AVD","23 = RemotePCStatic","24 = RemotePCDynamic","25 = AWSEC2","26 = Custom","27 = NutanixPC"]],"type":"string","description":"<para type=\"synopsis\">Provider Major Type</para>\r\n<para type=\"description\"></para>","format":"int32"},"AllowURLAndMailRedirection":{"enum":[["0 = Disabled","1 = Enabled","2 = EnabledWithAppRegistration"]],"type":"string","description":"<para type=\"synopsis\">URL and Mail Redirection values.</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"FileTransferControlMode":{"enum":[["0 = Disabled","1 = ClientToServer","2 = ServerToClient","3 = Bidirectional"]],"type":"string","description":"<para type=\"synopsis\">File Transfer Control modes.</para>\r\n<para type=\"description\"></para>","format":"int32"},"FileTransferExistingFileMode":{"enum":[["0 = CreateNewFile","1 = OverwriteExistingFile"]],"type":"string","description":"<para type=\"synopsis\">File Transfer Existing File modes.</para>\r\n<para type=\"description\"></para>","format":"int32"},"PrnNameFormat":{"enum":[["0 = PrnFormat_PRN_CMP_SES","1 = PrnFormat_SES_CMP_PRN","2 = PrnFormat_PRN_REDSES"]],"type":"string","description":"<para type=\"synopsis\">Printer Name Format</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"DriveRedirectionFileCacheMode":{"enum":[["0 = None","1 = ReadAhead","2 = ReadAheadWriteBehind"]],"type":"string","description":"<para type=\"synopsis\">Drive Redirection File Caching Mode</para>\r\n<para type=\"description\"></para>","format":"int32"},"ManageRDPTransportProtocol":{"enum":[["0 = Disabled","1 = BothUDPTCP","2 = OnlyTCP","3 = EitherUDPTCP"]],"type":"string","description":"<para type=\"synopsis\">Manage RDP transport protocol.</para>\r\n<para type=\"description\"></para>","format":"int32"},"AdminCredential":{"type":"object","properties":{"enabled":{"type":"boolean","description":"<para type=\"description\">Whether credentials are enabled or not.</para>"},"priority":{"type":"integer","description":"<para type=\"description\">The priority</para>","format":"int32"},"username":{"type":"string","description":"<para type=\"description\">Username</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">Admin Credentials</para>\r\n<para type=\"description\"></para>"},"CustomizationVariable":{"type":"object","properties":{"name":{"type":"string","description":"<para type=\"description\">Variable name.</para>","nullable":true},"value":{"type":"string","description":"<para type=\"description\">Value of the variable.</para>","nullable":true},"type":{"$ref":"#/components/schemas/VariableType"}},"additionalProperties":false,"description":"<para type=\"synopsis\">Customization - Variable</para>\r\n<para type=\"description\"></para>"},"VariableType":{"enum":[["0 = Regular","1 = Secure"]],"type":"string","description":"<para type=\"synopsis\">Variable Type</para>\r\n<para type=\"description\"></para>","format":"int32"},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.parallels.com/landing/ras-rest-api-guide/api-reference/infrastructure/providers/custom.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
